--*****************************************************************
--* UPCNT12L :-                                                    *
--*                                                               *
--* 12 bit up counter using Altera LPM                            *
--*                                                               *
--*****************************************************************

library IEEE;
use IEEE.std_logic_1164.all;
library LPM;
use LPM.lpm_components.all;


entity UPCNT12L is
  port(
    clock  : in  std_logic;
--     cnt_en : in  std_logic;
    q      : out std_logic_vector(11 downto 0);
    aclr   : in  std_logic;
    sclr   : in  std_logic
    );
end UPCNT12L;


architecture archUPCNT12L of UPCNT12L is

    SIGNAL sub_wire0    : STD_LOGIC_VECTOR (11 DOWNTO 0);

    COMPONENT lpm_counter
    GENERIC (
        lpm_width       : NATURAL;
        lpm_type        : STRING;
        lpm_direction   : STRING
    );
    PORT (
            sclr    : IN STD_LOGIC ;
            aclr    : IN STD_LOGIC ;
            clock   : IN STD_LOGIC ;
            q       : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
    );
    END COMPONENT;

BEGIN
    q    <= sub_wire0(11 DOWNTO 0);

    lpm_counter_component : lpm_counter
    GENERIC MAP (
        lpm_width => 12,
        lpm_type => "LPM_COUNTER",
        lpm_direction => "UP"
    )
    PORT MAP (
        sclr => sclr,
        aclr => aclr,
        clock => clock,
        q => sub_wire0
    );

end archUPCNT12L;







